# by plushpuffin@wwddfd.com
# http://www.wwddfd.com
# ISoar Addon v4.0
push(@Addons_Loaded, 'ISoar 4.0');
push(@Addons_PageHandler, 'ISoarPageHandler');
push(@Addons_MainPage, 'ISoar_MainPage');
push(@Addons_NPHTMLFoot, 'ISoar_HTMLFoot');
push(@Addons_LoadHelp, 'ISoar_LoadHelp');
$Addons_List{'ISoar 4.0'} = ['npa_isoar.pl', "Ground Control to Major Tom. Ground Control to Major Tom."];

sub ISoar_LoadHelp {
	if( $Help{'isoar'} ) { return; }
	$Help{'isoar'} = qq~
	ISoar lists all the hexadecimal color values it found in newspro.cgi<br><br>
	DO NOT make these values "black" or "blue" or whatever. ALWAYS USE HEXADECIMAL<br>
	DO NOT use a # in the field.<br>
	You can see some nice colors at: <a href="http://www.users.interport.net/%7Egiant/COLOR/1ColorSpecifier.html">HYPE's Color Specifier</a><br>
	Again, don't use the NAMES of the colors, only the HEXADECIMAL values:<br><br>
	eg:<br>
	Snow 255 250 250 #FFFAFA<br>
	use the FFFAFA part, not the name!<br><br><br><br>
	a good hint: if you want to make items in ISoar the SAME color, you should try to distinguish them so that you can make them both different colors later on. Do this by using a combination of uppercase and lowercase letters.<br><br>
	eg:<br>
	FFFAFA CCCCCC<br>
	change to: FFAAAA FFAAaA<br><br>
	a single letter difference in capitalization is all it takes!<br><br>
	If the color you're choosing is all digits, such as 000000, simply make the color the next one up: 000001<br>
	The difference isn't really noticeable.<br><br>
	<HR width="75%"><br><br>
	Version 2.0 of ISoar has a few new features.<br><br>
	For Internet Explorer users, the colors of the preview boxes change right away when you edit the text fields!<br>
	Netscape users can click the PREVIEW button to see the changes, since this doesn't work in Netscape.<br><br>
	There is now a DEMO button, too..so you can see what your main page will look like with the new colors...just click DEMO to see it, and click the back button on your browser when you're done.<br><br>
	After using the DEMO button and returning to the ISoar page, you must sometimes click on the PREVIEW button, since the page kind of &quot;forgets&quot; which colors go where...<br><br>
	On a side note, there is now a RESET button which resets all the text boxes to their default values.<br><br>
	<HR width="75%"><br><br>
	Version 3.0 of ISoar adds a conversion wizard to aid you in retaining color settings when upgrading to a new version of newspro.<br><br>
	ISoar now lists the hex values of the previous colors when you are editing, for your convenience.<br><br>
	Also, ISoar no longer requires a temporary file when creating the demo page for viewing.<br><br>
	<HR width="75%"><br><br>
	Version 4.0 of ISoar gives ISoar a stylish color for no particular reason. It might, however, come in handy if you accidentally choose ugly colors that are hard to see; you won't have to stare at those ugly colors while you're changing them back in ISoar. :)<br><br>
	ISoar 4.0 also changes the action of the DEMO button so that it opens a popup window; very convenient!<br><br>
	<HR width="75%"><br><br>
	<br><br><br>ISoar, by <a href="mailto:plushpuffin\@wwddfd.com">plushpuffin</a><br>
	<a href="http://www.wwddfd.com">plushpuffin's perl garden</a><br><br><br><HR width="75%"><br>
	<br><br><br>javascripting by <a href="mailto:gogetassj4\@dragonworld.com.ar">GogetaSSJ4</a><br>
	<a href="http://www.dragonworld.com.ar">GogetaSSJ4's site: www.dragonworld.com.ar</a>
	~;
}

sub ISoarPageHandler {
	if ($qstring eq "isoar") {
		&ISoarMain;
		exit;
	}
	elsif( $qstring eq "help/isoar" ) {
		&ISoarHelp;
		exit;
	}
	elsif ($qstring eq "isoardemoclose") {
		print q~<html><head><title>closing popup!</title></head><body onLoad="window.close()">closing popup!</body></html>~;
		exit;
	}
	elsif( $qstring =~ m~isoardemo~ ) {
		&ISoarDemoColors;
		exit;
	}
}

sub ISoarHelp {
	&ISoarHead("ISoar Help");
	&ISoar_LoadHelp;
	print $Help{'isoar'};
	&NPHTMLFoot;
}

sub ISoar_HTMLFoot {
	if ($up == 3) {
		print qq~ <a href="$scripturl?isoar" class="navlink">ISoar4</a> |~;
	}
}

sub ISoar_MainPage {
	if ($up == 3) {
		print qq~
		<b><a href="$scripturl?isoar">ISoar4</a>:</b> This is Ground Control to Major Tom!<br><br>
		~;
	}
}

sub ISoar_Load {
	my ($results, $npfile) = @_;
	my @cursor;
	my $icolor;
	NPopen('NPF', $npfile);
	while( <NPF> ) {
		if( $_ eq "\n" ) { next; }
		@cursor = $_ =~ m~#([\w]{6})\W~g;
		if( @cursor ) {
			foreach $icolor (@cursor) {
				unless( $$results{$icolor} ) {
					$$results{$icolor} = 1;
				}
			}
		}
	}
	close( NPF );
}

sub ISoar_LoadAll {
	my ($results, $npfile) = @_;
	my @cursor;
	my $icolor;
	NPopen('NPF', $npfile);
	while( <NPF> ) {
		if( $_ eq "\n" ) { next; }
		@cursor = $_ =~ m~#([\w]{6})\W~g;
		if( @cursor ) {
			foreach $icolor (@cursor) {
				push( @$results, $icolor );
			}
		}
	}
	close( NPF );
}

sub ISoarDoReplace {
	my ($chfile,$modfile,$oldfile) = @_;
	my $errorcheck = 0;
	my ( $key, $value, %colors, @cursor, $errormsg );
	while( ($key, $value) = each(%in) ) {
		if( $key =~ m~isoarv(.*)~ ) {
			if( $1 ne $value ) { $colors{"$1"} = $value; }
			unless( $value =~ m~[\d|a-f|A-F]{6}~ ) { $errorcheck = 1; $errormsg .= qq~Invalid character in color value: "$value"<br><br>~; }
		}
	}
	if( $errorcheck ) { NPdie( qq~<br><br><font size="+2" style="font-size: 1.5em">$errormsg<br><br>
		You may only use the digits '0' through '9' and <br>the letters 'A' through 'F' or 'a' through 'f'<br><br>
Valid characters include : 0123456789abcdefABCDEF</font><br><br><br><hr>~ ); }
	&NPopen('NPF', "$chfile");
	&NPopen('NPFNew', ">$modfile");

	while( <NPF> ) {
		if( $_ eq "\n" ) { print $_; next; }
		@cursor = $_ =~ m~#([\w]{6})\W~g;
		if( @cursor ) {
			foreach $icolor (@cursor) {
				if( $colors{$icolor} ) {
					$_ =~ s~$icolor~$colors{$icolor}~g;
				}
			}
		}
		print NPFNew $_;
	}
	close( NPF );
	close( NPFNew );
	if( -e $oldfile ) {
		unlink( $oldfile );
	}
	chmod 0755, $modfile;
	rename($chfile, $oldfile);
	rename($modfile, $chfile);

}

sub ISoarDeathRays {
	my $scriptname = $ENV{'SCRIPT_NAME'};
	$scriptname =~ s~.*/(.*)~$1~;
	$scriptname ||= q~newspro.cgi~;
	my $chfile = $scriptname;
	my $modfile = "n$chfile";
	my $oldfile = "o$chfile";
	&ISoarDoReplace( $chfile, $modfile, $oldfile );
	&ISoarHead("ISoar", qq~ISoarDemo('$scripturl?isoardemoclose','isoardemo','500','320','yes','0');~ );
		print qq~<br>$chfile was renamed $oldfile, and the modified $modfile was renamed to take its place.<br>
	The changes will appear the next time you refresh the page.<br>
	If the server no longer works, you may have to reset permissions on the new file $chfile.<br>
	This addon has already attempted to reset the permissions to 0755, so you might not have to bother...~;
	&NPHTMLFoot;
	exit;
}

sub ISoarConvert {
	my $depth = $in{'isoarconvertw'} || 0;
	$depth++;
	&ISoarHead(qq~ISoar Conversion Wizard : step $depth~);
	print qq~<div align="center"><form name="convw" action="$scripturl?isoar" method="POST">~;
	if( $depth == 1 ) {
		print qq~<h3>Welcome to ISoar's newspro conversion wizard</h3><BR>
This will help you migrate to a new version of newspro.cgi while still maintaining your color settings.<BR><BR>
Here is what you should do:<BR>
<div align="left"><ul><ul><ul><ul>
<li>Rename your old, customized newspro file to o_newspro.cgi or whatever you want.</li>
<li>Install the new, ugly newspro file. You should not rename this new file.<BR>
Some servers, however, require that CGI programs be named newspro.pl - So go ahead and use that.</li>
<li>Run the ISoar Conversion wizard from the ugly newspro.</li>
</ul></ul></ul></ul></div><BR><HR>
Do not proceed until you have accomplished this.<BR><BR>
<HR size="5"><BR>
<b>Please note:</b> if you combined two colors into one in your custom newspro.cgi then this wizard might screw up.<BR>
<b>We apologize for the inconvenience.</b><BR><BR>
<input type="submit" name="isnextstep" value="Continue">
~;
	}
	elsif( $depth == 2 ) {
		print qq~<h3>Choose the old file with the customized colors</h3><BR>
Please specify the relative location of your OLD newspro.cgi installation, with the custom colors.<BR>
If you used a name other than the one ISoar recommended, fill it in here.<BR>
<input type="text" name="oldnploc" value="o_newspro.cgi"><BR><BR>
<input type="submit" name="isnextstep" value="Continue">
~;
	}
	elsif( $depth == 3 ) {
		my $scriptname = $ENV{'SCRIPT_NAME'};
		$scriptname =~ s~.*/(.*)~$1~;
		$scriptname ||= q~newspro.cgi~;
		print qq~<h3>Choose the new file with the default colors</h3><BR>
Please specify the relative location of your NEW newspro.cgi installation. (the one with the ugly default colors)<BR>
ISoar has attempted to fill this in for you, but may not have been entirely successful.<BR>
(this should be the name of the newspro script that you are running right now)<BR>
<input type="hidden" name="oldnploc" value="$in{'oldnploc'}">
<input type="text" name="newnploc" value="$scriptname"><BR><BR>
<input type="submit" name="isnextstep" value="Continue">
~;
	}
	elsif( $depth == 4 ) {
		my (@badcolors, @goodcolors,$custompro,$updatepro,$i,$icolor,$changecolor,$counter,%colors);
		$updatepro = $in{'newnploc'};
		$custompro = $in{'oldnploc'};
		print qq~
<h3>ISoar is now attempting to pass your custom colors to the new newspro.cgi file</h3><BR>
old newspro: $in{'oldnploc'}<BR>
new newspro: $in{'newnploc'}<BR><HR size="5"><BR>
~;
		&ISoar_LoadAll( \@badcolors, $updatepro );
		&ISoar_LoadAll( \@goodcolors, $custompro );
		for( $i = 0; $i < @badcolors; $i++ ) {
			unless( $#goodcolors >= $i ) { last; }
			$colors{$badcolors[$i]} = $goodcolors[$i];
		}
		print qq~<table width="100%"><tr>~;
		$counter = 1;
		while( $icolor = each(%colors) ) {
			$changecolor = $colors{$icolor};
				print qq~
			<td width="64">#$icolor</td><td bgcolor="#$icolor">&nbsp&nbsp&nbsp</td>
			<td bgcolor="#$changecolor" id="IS$icolor">&nbsp&nbsp&nbsp</td>
			<td>
			<input type="text" name="isoarv$icolor" value="$changecolor" size="8" maxlength="6"
				onChange="document.all.IS$icolor.bgColor=(isoarv$icolor.value)">
			</td>
			~;
			$counter++;
			if( $counter % 2 ) { print "</tr><tr>"; }
		}
		print qq~</table><br><br>
<input type="submit" name="isoarpreview" value="PREVIEW"><br>
Netscape users must click here to PREVIEW colors<br><br><br>
<input type="submit" name="isoardemo" value="DEMO"><br>
ALL BROWSERS - Click here for a DEMO...then click your browser's back button to return to ISoar<br><br><br><br>
<input type="submit" name="isoarsubmit" value="Save Changes">
<input type="submit" name="isoarreset" value="Reset All"><BR><BR>
~;
		print qq~<BR><HR size="5"><h3>Colors from your old newspro.cgi have been loaded into the form. You may
now work with them as you would normally. Have a <u><b><i>nice</i></b></u> day</h3>~;
	}
	else {
		print qq~Holy Crap. How did you get to this page? Out! Out, damn spot!~;
	}
	if( $depth != 4 ) {
		print qq~<input type="hidden" name="isoarconvertw" value="$depth">~;
	}
	print qq~</form></div>~;
	&NPHTMLFoot;
	exit;
}


# ISoarHead: Displays the standard HTML header used by all script pages.
# If you'd like to change the look and feel of the script, edit the following two routines.
sub ISoarHead {
	local $title = shift;
	my $onloadcode = shift;
	print qq~
	<html>
	<head>
	<title>$Messages{'NewsPro'}: $title</title>
	$Messages{'ContentType'}
	~;
	if ($NPConfig{'BasicLayout'} == 0) {
	print qq~
	<style type="text/css">
<!--
p {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt}
.navbar {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt}
.navlink {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt; color: #ffffff}
td {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt}
A:hover { color: #ffffff; text-decoration: none}
.nptitle { }
.npcontent { }
.npfooter { }
-->
</style>
<script language="JavaScript">
<!--
function ISoarDemo(mypage, myname, w, h, scroll, focusme) {
var winw = (screen.width - w) / 2;
var winh = (screen.height - h) / 2;
winprops = 'height='+h+',width='+w+',top='+winh+',left='+winw+',scrollbars='+scroll+',resizable'
win = window.open(mypage, myname, winprops)
if (parseInt(navigator.appVersion) >= 4 && focusme == 1) { win.window.focus(); }
}
//-->
</script>
	~;
	}
	print '</head>';
	if ($NPConfig{'BasicLayout'}) {
		print qq~
		<body>
		<center><h2>$NPConfig{'SiteTitle'}: $title</h2></center>
		<table width="85%" border=1 align="center"><tr><td>
		~;
	} else {
	print qq~<body bgcolor="#000000" text="#ffffff" link="#FFCC33" vlink="#FFCC33" alink="#FFCC33" onLoad="$onloadcode">~;
	print qq~
	<div align="center">
<!--VirtualAvenueBanner-->
<!--#echo banner=""-->
	  <table width="60%" border="1" bordercolor="#ffffff" cellpadding="4" cellspacing="0" align="center" class="nptitle">
	    <tr bgcolor="#000099"> 
	      <td>
	        <div align="center"><b><font face="Verdana, Arial, Helvetica, sans-serif" color="#FFCC33">$NPConfig{'SiteTitle'}: $title</font></b></div>
	      </td>
	    </tr>
	  </table>
<br>
	  <table width="90%" border="1" bordercolor="#ffffff" cellpadding="8" cellspacing="0" align="center" class="npcontent">
	    <tr bgcolor="#000000"> 
      <td>
~;
	}
	$HTMLHeaderPrinted = 1;
}

sub ISoarDemoColors {
	my $errorcheck = 0;
	my ( $originalcolor, $democolor, %colors, @colors, $icolor, $errormsg );
	$qstring =~ m~\Aisoardemo(.*)\Z~;
	my $getstring = $1;
	while( $getstring =~ m~/([^=]*)=([^/]*)~g ) {
		$originalcolor = $1;
		$democolor = $2;
		if( $originalcolor ne $democolor ) { $colors{$1} = $2; }
		unless( $democolor =~ m~[\d|a-f|A-F]{6}~ ) { $errorcheck = 1; $errormsg .= qq~Invalid character in color value: "$originalcolor --&gt; $democolor"<br><br>~; }
	}
	if( $errorcheck ) { &NPdie( qq~<br><br><font size="+2" style="font-size: 1.5em">$errormsg<br><br>
		You may only use the digits '0' through '9' and <br>the letters 'A' through 'F' or 'a' through 'f'<br><br>
Valid characters include : 0123456789 abcdef ABCDEF</font><br><br><br><hr>~ ); }
	my @colors = keys %colors;
	my $fbf = '';
	tie *$fbf, 'Tie::FHRS', \$fbf;
	my $innertube = select $fbf;
	@Addons_NPHTMLFoot = ();
	&NPHTMLHead("ISoar Color Demo. Close this window when finished editing.");
	print q~
this <a href="$scripturl?$qstring">link here</a> is a color demo. &lt;HR&gt; tag below..<br>
<hr>
~;
	&NPHTMLFoot();
	select $innertube;
	untie $fbf;
	$fbf =~ s~<a\s~<a onClick="return false;" ~gio;
	$fbf =~ s~<form\s~<form onSubmit="return false;" ~gio;
	foreach $icolor (@colors) {
		if( $colors{$icolor} ) {
			$fbf =~ s~$icolor~$colors{$icolor}~g;
		}
	}
	print $fbf;
	exit;
}

sub ISoarMain {
	unless ($UserPermissions{$Cookies{'uname'}} == 3) {
		&NPdie('You are not authorized to access this');
	}
	my $onloadcode;
	if( $in{'isoardemo'} ) {
		my( $originalcolor, $democolor, $invalue, $getstring );
		foreach my $invalue (keys %in) {
			unless( $invalue =~ m~\Aisoarv(.*)\Z~ ) { next; }
			$originalcolor = $1;
			$democolor = $in{$invalue};
			$getstring .= qq~/$originalcolor=$democolor~;
		}
		$onloadcode = qq~ISoarDemo('$scripturl?isoardemo$getstring','isoardemo','500','320','yes','1');~;
	}
	if( $in{'isoarsubmit'} ) {
		&ISoarDeathRays;
	}
	if( $in{'isoarconvert1'} || $in{'isoarconvertw'} ) {
		&ISoarConvert;
	}
	my %colors;
	my $scriptname = $ENV{'SCRIPT_NAME'};
	$scriptname =~ s~.*/(.*)~$1~;
	$scriptname ||= q~newspro.cgi~;
	&ISoar_Load( \%colors, $scriptname );
	my $counter = 1;
	my $isreset = $in{'isoarreset'};
	my ( $icolor, $key, $value, $changecolor );
	my @colors = keys %colors;

	&ISoarHead( "ISoar", $onloadcode );

	print qq~
	<table width="100%"><tr><td align="left">
	written by <a href="mailto:plushpuffin\@wwddfd.com">plushpuffin</a><br>
	<a href="http://www.wwddfd.com" target="window1">plushpuffin's perl garden</a></td>
	<td align="right">
	javascripting by <a href="mailto:gogetassj4\@dragonworld.com.ar">GogetaSSJ4</a><br>
	<a href="http://www.dragonworld.com.ar" target="window2">Dragon World</a></td></tr></table><br>
	<form name="colorsel" action="$scripturl?isoar" method="POST">
	~;

	print qq~
	<div align="center"><h3>NewsPro ISoar Colors</h3>
	by plushpuffin<br><br><a href="$scripturl?help/isoar" target="window">Help on ISoar</a><br><br><br>
	<table width="100%"><tr>
	~;

	foreach $icolor (@colors) {
		$changecolor = $isreset ? $icolor : $in{"isoarv$icolor"} || $icolor;
		print qq~
		<td width="64">#$icolor</td><td bgcolor="#$icolor">&nbsp&nbsp&nbsp</td>
		<td bgcolor="#$changecolor" id="IS$icolor">&nbsp&nbsp&nbsp</td>
		<td>
		<input type="text" name="isoarv$icolor" value="$changecolor" size="8" maxlength="6"
			onChange="document.all.IS$icolor.bgColor=(isoarv$icolor.value)">
		</td>
		~;
		$counter++;
		if( $counter % 2 ) { print "</tr><tr>"; }
	}
	print qq~</table><br><br>
	<input type="submit" name="isoarpreview" value="PREVIEW"><br>
	Netscape users must click here to PREVIEW colors<br><br><br>
	<input type="submit" name="isoardemo" value="DEMO"><br>
	ALL BROWSERS - Click here to see a DEMO in a popup window!<br><br><br><br>
	<input type="submit" name="isoarsubmit" value="Save Changes">
	<input type="submit" name="isoarreset" value="Reset All"><BR><BR>
	<HR size="5"><BR>
	<input type="submit" name="isoarconvert1" value="Convert NewsPro After Upgrade">
	</form><br></div>
	~;
	&NPHTMLFoot;
}
1;
#####################################################
package Tie::FHRS;
sub TIEHANDLE {
	my $class = shift;
	my $self = shift;

	return bless $self, $class;
}

sub PRINT {
	my $self = shift;
	$$self .= join('', @_);
	return 1;
}
1;
#####################################################